import javax.swing.JPanel;
import java.awt.event.*;
import java.awt.event.MouseAdapter;
import java.awt.*;
import java.awt.Cursor;


public class MouseListener extends MouseAdapter {
   private MyWorld world;
   private PhysicsElement ele;  
	private Drawable currentElement;
   private JPanel panel;
   public MouseListener (MyWorld w, JPanel p){
      world = w;
      panel = p;
   } 
   public void mouseMoved(MouseEvent e) {
      Drawable newElement = world.find(e.getX(), e.getY());
      if (newElement == currentElement) return;
      if (currentElement != null) {
         currentElement.setReleased();
         currentElement = null;
      }
      if (newElement != null) { 
         currentElement = newElement;
         currentElement.setSelected();
      }
      panel.repaint();
  
    }
	 
	 public void mouseClicked(MouseEvent e)
    {
	      currentElement = world.find(e.getX(), e.getY());
		   ele = (PhysicsElement) currentElement;  
			
			if(panel.getCursor().getType()==Cursor.CROSSHAIR_CURSOR){
           if (currentElement != null && e.getClickCount() >= 1)
           world.removeElement(ele);
           world.resetCursor();
	      }
	 }

	 
	 
	 
	 
	 
	 
	 
	 
	 
	 
	 
	 
	 
	 
	 
  
   public void mouseDragged(MouseEvent e) {
      if (currentElement == null) return;
      currentElement.dragTo(e.getX(), e.getY());
      panel.repaint();
   }
   
		
	
	public void mouseReleased(MouseEvent e) {
      if (currentElement != null) 
         currentElement.setReleased();
      	   if (!(currentElement instanceof GRubber)&&(!(currentElement instanceof GSpring))){
				    currentElement = null;
           return;
            }   
   
	   	 // we dragged an attachable element
          // we dragged a spring, so we look for and attachable element near by  
      AttachableElement element = world.findAttachableElement(e.getX(), e.getY());
      if (element == null) {
         currentElement = null;
         return;
      }
      // we dragged a spring and it is near an attachable element,
      // so we hook them to the right spring end.
     if(currentElement instanceof GRubber){
				
      GRubber rubber = (GRubber) currentElement;
		Vector2D a=rubber.getAendPosition();
      if ((a.getX()==e.getX()) && (a.getY()==e.getY())) rubber.attachAend(element);
		Vector2D b=rubber.getBendPosition();
      if ((b.getX()==e.getX()) && (b.getY()==e.getY())) rubber.attachBend(element);
		currentElement = null;
      panel.repaint();      
    }
	  
	  if(currentElement instanceof GSpring){
	   		
      GSpring spring = (GSpring) currentElement;
		Vector2D u=spring.getAendPosition();
      if ((u.getX()==e.getX()) && (u.getY()==e.getY())) spring.attachAend(element);
		Vector2D z =spring.getBendPosition();
      if ((z.getX()==e.getX()) && (z.getY()==e.getY())) spring.attachBend(element);
		currentElement = null;
      panel.repaint();
	  }	
	
	
	}
	

	
}